function [ output_args ] = genOAC( input_args )
% 
% Author: Yasuko Matsubara
%
% genOAC()
%
% generate synthetic O & A & C matrix
%
%


u=100;
v=1000;
n=100;
k=3;
dir='./';

if(1==0)
x=1:v;
a1=beta(x, 1).*rand(1, length(x))*0.001;
a1=a1./sum(a1);
a2=gampdf(x, 200, length(x)/100); %+rand(1, length(x))*0.02;
a2=a2./sum(a2);
a3=gampdf(x, 50, length(x)/100).*rand(1, length(x))*0.001;
a3=a3./sum(a3);
A=[a1; a2; a3;];
A=A';
end


A=[];
for r=1:v
    a=zeros(1,k);
    a(1,floor(rand*k)+1)=1;
    a = a + rand(1, k)*0.1/k;
    a = a./sum(a);
    A=[A; a];
end
A=A';
% normalize
B=sum(A');
A=A./(repmat(B',1,v));
A=A';

O=[];
for r=1:u
    o=zeros(1,k);
    o(1,floor(rand*k)+1)=1;
    o = o + rand(1, k)*0.1;
    o=o./sum(o);
    O=[O; o];
end


x=1:n;
c1=sin(x/4)+1;
c1=c1./sum(c1);
c2=-1*sin(x/4+1)+1;
c2=c2./sum(c2);
c3=sin(x/16)+1;
c3=c3./sum(c3);
C=[c1; c2; c3;];
C=C';   


save([dir,'A'], 'A', '-ascii')
save([dir,'O'], 'O', '-ascii')
save([dir,'C'], 'C', '-ascii')
end

