/* 
 * trimine.c --- written by Yasuko Matsubara 2012.6.7
 */

#include        <stdio.h>
#include        <string.h>
#include        <stdlib.h>
#include        <math.h>
#include	"trimine.h"
#include	"tool.h"


int main(int argc, char** argv){

  TRIMINE model;
  double timecnt, totaltime;
  char tmp[BUFSIZE];

  if(argc != 7)
	error("Usage: cmd #topics #objects #actors #duration inputfn outputfn", argv[0]);

  model.k=atoi(argv[1]);
  model.u=atoi(argv[2]);
  model.v=atoi(argv[3]);
  model.n=atoi(argv[4]);
  char* infn=argv[5];
  char* outfn=argv[6];

  //--- print status
  fprintf(stderr, "k=%d\n", model.k);
  fprintf(stderr, "u=%d\n", model.u);
  fprintf(stderr, "v=%d\n", model.v);
  fprintf(stderr, "n=%d\n", model.n);
  fprintf(stderr, "in %s\n", infn);
  fprintf(stderr, "out %s\n", outfn);

  int nline = count_lines(infn);
  if((model.n > nline))
    model.n = nline;

  fprintf(stderr, "load dataset...%d \n", model.n);
  malloc_read(infn, &model);
  init_model(&model);

  fprintf(stderr, "sampling start... (iter=%d)\n", STEP);
  int wantOptEst = 1;

  timecnt = getrusage_sec(); 
  //---------------------------//
  inference(&model, wantOptEst);
  //---------------------------//
  totaltime = getrusage_sec() - timecnt;
  printf("%.4f sec.\n",totaltime);
  calcParams(&model);
  writeParams(outfn, &model);
  free_model(&model);

}


