/* 
 * trimine.h --- written by yasuko matsubara 2012.6.7
 */



#include        <stdio.h>
#include        <string.h>
#include        <stdlib.h>
#include        <math.h>

#define   BUFSIZE	256
#define   STEP		20 //50 //20 
#define   ESTFREQ	1 
#define   MAXK    	100
#define   INF 		10000000

typedef struct {
  int    NM; 	// # total count
  int   *Mx;	// # of count for each objects Mx[u]
  int **ind; 	// actor index          ind[u][Mx[]]
  int   **x; 	// count of each actor   x[u][Mx[]]
  int    *z;   	// assigned topic        z[NM]
} DATA;


typedef struct {
  int     u; 	// # objects
  int     v; 	// # actors
  int     k; 	// # topics
  int     n;    // # duration 

  DATA *tensor; //tensor[n]

  int NM; //# of total count

  double** A;    // Actor matrix  A[k][v]  
  double** O;    // Object matrix O[k][u]
  double** C;    // Time matrix   C[k][n]

  double alpha;
  double beta;
  double gamma;

  int** Nkv;
  int** Nku;
  int** Nkn;
  int*  Nk;
  int*  Nu;

} TRIMINE;

//inferCP.c
void init_model();
double logsumexp();
void free_model();
void writeParams();
void inference();
void calcParams();

