function triplot()

% 
% Author: Yasuko Matsubara
%
% TriPlot consists of 
%       - two ternary plots
%       - one time plot
%	also see "./figs/"
%	

%--- setting ------------------%
% model dir
dir='./dat/';
%dir='./output/model/';

% select three topics (any integer : 1, ..., k)
a=1;
b=2;
c=3;
% label
al='"topic a"';
bl='"topic b"';
cl='"topic c"';
%-----------------------------%


figure
X=load([dir,'O']);
plotTri(X, a, b, c, al, bl, cl);
figure
X=load([dir,'A']);
plotTri(X, a, b, c, al, bl, cl);
figure
X=load([dir,'C']);
plotTemp(X, a, b, c, al, bl, cl);

end

function plotTemp(X, a, b, c, alabel, blabel, clabel)

X=[X(:,a), X(:,b), X(:,c)];

plot(X);
legend(alabel, blabel, clabel);
xlim([1, length(X)])
xlabel('Time')

end

function plotTri(X, a, b, c, alabel, blabel, clabel)

X=[X(:,a), X(:,b), X(:,c)];

%normalize
X=X./max(X(:)).*0.9;


for k=1:1  
res=50;
map=zeros(res^2/2,1);
tris = zeros(res^2/2,3);
tris2d = zeros(res^2/2,2);

counter=0;
for i=1:res
    for j=1:res-i
        counter=counter+1;
        u = i/res;
        v = j/res;
        p = [u v 1-u-v];
        tris2d(counter,:)=[u v];
        tris(counter,:)=p;
        map(counter) = 0.001;
    end
end
tris=tris(1:counter,:);
tris2d=tris2d(1:counter,:);
D=delaunay(tris2d(:,1),tris2d(:,2));


colormap(cool)
trisurf(D,tris(:,1),tris(:,2),tris(:,3),'LineStyle','none','FaceColor',[0.9, 0.9, 0.9]); %, ...
camtarget([0 0 0]);
end

axis off
hold on;
campos([-2 -2 -2]);
plot3(X(:,1),X(:,2),X(:,3),'*','MarkerSize',4,'MarkerEdgeColor','r');
hold off;

text(1,0,0, alabel, 'FontSize', 18)
text(0,1,0, blabel, 'FontSize', 18)
text(0,0,1, clabel, 'FontSize', 18)

end
